﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("AllowEdit", typeof(bool));
            dt.Columns.Add("DependEditable", typeof(string)).DefaultValue = "Default Text";

            for (int i = 0; i < 10; i++)
            {
                dt.Rows.Add((i % 2 == 0));
            }

            ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["DependEditable"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
        }

        private void ultraGrid1_BeforeCellActivate(object sender, Infragistics.Win.UltraWinGrid.CancelableCellEventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;
            if (e.Cell.Column.Key == "DependEditable" && (bool)e.Cell.Row.Cells["AllowEdit"].Value)
            {
                e.Cell.IgnoreRowColActivation = true;
           
            }
        }

        private void ultraGrid1_BeforeCellDeactivate(object sender, CancelEventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;
            if (grid.ActiveCell.Column.Key == "DependEditable")
            {
                grid.ActiveCell.IgnoreRowColActivation = false;
            }
        }
    }
}
